/*
 Copyright (C) 2007 Christian Dywan <christian@twotoasts.de>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef __webView_H__
#define __webView_H__ 1

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "ui.h"
#include "browser.h"
#include "helpers.h"
#include "sokoke.h"
#include "debug.h"

#ifdef MIDORI_WEBKIT
    #include <webkitgtkpage.h>
    #include <webkitgtkframe.h>
    //#include <webkitgtknetworkrequest.h>
    #include <webkitgtkglobal.h>
#endif

#ifdef MIDORI_WEBKIT_ANTWORT
WebKitNavigationResponse on_webView_navigation_requested(GtkWidget* webView
 , WebKitFrame* frame, WebKitNetworkRequest* networkRequest);
#endif

void on_webView_location_changed(GtkWidget*, const gchar*, CBrowser*);

void on_webView_title_changed(GtkWidget*, const gchar*, const gchar*, CBrowser*);

// void on_frame_title_changed(WebKitFrame*, const gchar*, const gchar*, CBrowser*);

#ifdef MIDORI_WEBKIT
void on_webView_icon_changed(GtkWidget*, WebKitFrame*, CBrowser*);

void on_webView_load_started(GtkWidget* , WebKitFrame*, CBrowser*);
#endif

void on_webView_load_changed(GtkWidget*, gint progress, CBrowser*);

#ifdef MIDORI_WEBKIT
void on_webView_load_finished(GtkWidget*, WebKitFrame*, CBrowser*);
#endif

// void on_frame_cleared(WebKitFrame*, CBrowser*);

// void on_frame_load_done(WebKitFrame*, gboolean, CBrowser*);

void on_webView_status_message(GtkWidget*, const gchar*, CBrowser*);

void on_webView_selection_changed(GtkWidget*, CBrowser*);

gboolean on_webView_console_message(GtkWidget*, const gchar*
 , gint, const gchar*, CBrowser*);

gboolean on_webView_script_alert(GtkWidget*, gpointer, const gchar*, CBrowser*);

gboolean on_webView_script_confirm(GtkWidget*, gpointer, const gchar*
 , gboolean*, CBrowser*);

gboolean on_webView_script_prompt(GtkWidget*, gpointer, const gchar*
 , const gchar*, gchar**, CBrowser*);

// void on_webView_request_auth_prompt(GtkWidget*, CBrowser*);

// gboolean on_webView_set_cookie(GtkWidget*, CBrowser*);

void on_webView_link_hover(GtkWidget*, const gchar*, const gchar*, CBrowser*);

GtkWidget* on_webView_window_open(GtkWidget*, const gchar*, CBrowser*);

// void on_webView_window_features(GtkWidget*, CBrowser*);

gboolean on_webView_button_release(GtkWidget*, GdkEventButton*, CBrowser*);

void on_webView_popup(GtkWidget*, CBrowser*);

gboolean on_webView_scroll(GtkWidget*, GdkEventScroll*, CBrowser*);

gboolean on_webView_leave(GtkWidget*, GdkEventCrossing*, CBrowser*);

void on_webView_destroy(GtkWidget*, CBrowser*);

GtkWidget* webView_new(GtkWidget**);

void webView_load_from_uri(GtkWidget*, const gchar*);

void webView_load_from_string(GtkWidget*, const gchar*);

gchar* webView_copy_source(GtkWidget*);

void webView_go_back(GtkWidget*);

void webView_go_forward(GtkWidget*);

void webView_refresh(GtkWidget*, gboolean);

void webView_stop(GtkWidget*);

gboolean webView_can_go_back(GtkWidget*);

gboolean webView_can_go_forward(GtkWidget*);

G_CONST_RETURN gchar* webView_get_uri(GtkWidget*);

G_CONST_RETURN gchar* webView_get_title(GtkWidget*);

gboolean webView_find(GtkWidget*, const gchar*, gboolean, gboolean, gboolean);

gboolean webView_can_increase_text_size(GtkWidget*);

gboolean webView_can_decrease_text_size(GtkWidget*);

void webView_set_text_size(GtkWidget*, gfloat);

gfloat webView_get_text_size(GtkWidget*);

gboolean webView_can_cut_clipboard(GtkWidget*);

gboolean webView_can_copy_clipboard(GtkWidget*);

gboolean webView_can_paste_clipboard(GtkWidget*);

void webView_cut_clipboard(GtkWidget*);

void webView_copy_clipboard(GtkWidget*);

void webView_paste_clipboard(GtkWidget*);

void webView_delete_selection(GtkWidget*);

gchar* webView_get_selected_text(GtkWidget*);

void webView_select_region(GtkWidget*, gint, gint);

gchar* webView_get_chars(GtkWidget*, gint, gint);

gboolean webView_get_selection_bounds(GtkWidget*, gint*, gint*);

void webView_close(GtkWidget*, CBrowser*);

#endif /* !__webView_H__ */
